%define anolis_release 4

Name:           perl-HTTP-Tiny
Version:        0.082
Release:        %{anolis_release}%{?dist}
Summary:        A simple, small correct HTTP/1.1 client
License:        GPL+ or Artistic
URL:            https://metacpan.org/release/HTTP-Tiny
Source0:        https://cpan.metacpan.org/authors/id/D/DA/DAGOLDEN/HTTP-Tiny-%{version}.tar.gz

Patch0001:      0001-HTTP-Tiny-0.070-Croak-on-failed-write-into-a-file.patch

BuildArch:      noarch

BuildRequires:  make coreutils 
BuildRequires:  perl-interpreter perl(ExtUtils::MakeMaker) >= 6.76 perl-generators
BuildRequires:  perl(Carp) perl(Errno) perl(Fcntl) perl(IO::Socket)
BuildRequires:  perl(Config) perl(strict) perl(warnings) perl(bytes) 
BuildRequires:  perl(MIME::Base64) perl(Socket) perl(Time::Local)
# Tests:
BuildRequires:  perl(Exporter) perl(File::Basename) perl(lib)
BuildRequires:  perl(File::Spec) perl(File::Temp)
BuildRequires:  perl(IO::File) perl(IO::Dir) perl(IO::Socket::INET)
BuildRequires:  perl(IPC::Cmd) perl(open) perl(Test::More) >= 0.96

Requires:       perl(MIME::Base64) perl(bytes) perl(Carp) perl(Fcntl) perl(Time::Local)

Recommends:     perl(IO::Socket::IP) >= 0.32
Recommends:     perl(IO::Socket::SSL) >= 1.56
Recommends:     perl(Mozilla::CA)

%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\(Util\\)
%global __requires_exclude %{__requires_exclude}|^perl\\(BrokenCookieJar\\)
%global __requires_exclude %{__requires_exclude}|^perl\\(SimpleCookieJar\\)
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_libexecdir}

%description
perl-HTTP-Tiny is a very simple HTTP/1.1 client designed for doing simple GET requests 
without the overhead of a large framework like LWP::UserAgent. It is more correct and 
more complete than HTTP::Lite. It supports proxiesand redirection. It also correctly 
resumes after EINTR.

If IO::Socket::IP 0.25 or later is installed, HTTP::Tiny will use it
instead of IO::Socket::INET for transparent support for both IPv4 and IPv6.

Cookie support requires HTTP::CookieJar or an equivalent class.

%package tests
Summary:        Test files for %{name}
Requires:       %{name} = %{EVR}
Requires:       perl(Test::Harness) perl(IO::Socket::SSL) >= 1.56 perl(IO::Socket::IP) >= 0.32

%description tests
The %{name}-tests is a subpackage of %{name}. Execute them with "%{_libexecdir}/%{name}/test".

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n HTTP-Tiny-%{version}

for F in t/*.t; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!.*perl\b}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PERLLOCAL=1 NO_PACKLIST=1
%{make_build}

%install
%{make_install}
%{_fixperms} '%{buildroot}'/*

# Install tests
mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t corpus %{buildroot}%{_libexecdir}/%{name}
cat > %{buildroot}%{_libexecdir}/%{name}/test << 'EOF'
#!/bin/sh
cd %{_libexecdir}/%{name} && AUTOMATED_TESTING=1 exec prove -I . -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}%{_libexecdir}/%{name}/test

%check
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
make test

%files
%license LICENSE
%{perl_vendorlib}/*
%{_mandir}/man3/*

%files tests
%{_libexecdir}/%{name}

%files doc
%doc CONTRIBUTING.mkdn Changes eg README

%changelog
* Tue Apr 11 2023 yuanhui <yuanhui@linux.alibaba.com> - 0.082-4
- Optimize the spec file

* Tue Feb 07 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.082-3
- remove versioned MODULE_COMPAT_ requires

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 0.082-2
- rebuild with perl 5.36.0

* Mon Jan 23 2023 Funda Wang <fundawang@yeah.net> - 0.082-1
- New version 0.082

* Sun Oct 09 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.080-2
- add doc package

* Fri Mar 11 2022 Renbo <rb01097748@alibaba-inc.com> - 0.080-1 
- Init for Anolis OS 23
